// Copyright (C) 2008, 2009 EPITA Research and Development Laboratory (LRDE)
//
// This file is part of Olena.
//
// Olena is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation, version 2 of the License.
//
// Olena is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Olena.  If not, see <http://www.gnu.org/licenses/>.
//
// As a special exception, you may use this file as part of a free
// software project without restriction.  Specifically, if other files
// instantiate templates or use macros or inline functions from this
// file, or you compile this file and link it with other files to produce
// an executable, this file does not by itself cause the resulting
// executable to be covered by the GNU General Public License.  This
// exception does not however invalidate any other reasons why the
// executable file might be covered by the GNU General Public License.

#ifndef MLN_ALL_HH
# define MLN_ALL_HH

/// \file
///
/// File that includes all the headers.
///
/// \todo Do not include essentials.


#include <mln/accu/all.hh>
#include <mln/arith/all.hh>
#include <mln/border/all.hh>
#include <mln/canvas/all.hh>
#include <mln/convert/all.hh>
#include <mln/core/all.hh>
#include <mln/data/all.hh>
#include <mln/debug/all.hh>
#include <mln/display/all.hh>
#include <mln/draw/all.hh>
#include <mln/estim/all.hh>
#include <mln/extension/all.hh>
//<<lrde
#include <mln/extract/all.hh>
//>>
#include <mln/fun/all.hh>
#include <mln/geom/all.hh>
#include <mln/graph/all.hh>
#include <mln/histo/all.hh>
#include <mln/io/all.hh>
#include <mln/labeling/all.hh>
#include <mln/linear/all.hh>
#include <mln/literal/all.hh>
#include <mln/logical/all.hh>
#include <mln/make/all.hh>
#include <mln/math/all.hh>
#include <mln/metal/all.hh>
#include <mln/morpho/all.hh>
#include <mln/norm/all.hh>
#include <mln/opt/all.hh>
#include <mln/pw/all.hh>
//<<lrde
#include <mln/registration/all.hh>
//>>
#include <mln/set/all.hh>
//<<lrde
#include <mln/subsampling/all.hh>
//>>
#include <mln/tag/all.hh>
#include <mln/test/all.hh>
#include <mln/trace/all.hh>
#include <mln/trait/all.hh>
#include <mln/util/all.hh>
#include <mln/value/all.hh>
#include <mln/win/all.hh>
#include <mln/world/all.hh>

#include <mln/essential/1d.hh>
#include <mln/essential/2d.hh>
#include <mln/essential/3d.hh>

#endif // ! MLN_ALL_HH
