// Copyright (C) 2008, 2009 EPITA Research and Development Laboratory (LRDE)
//
// This file is part of Olena.
//
// Olena is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation, version 2 of the License.
//
// Olena is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Olena.  If not, see <http://www.gnu.org/licenses/>.
//
// As a special exception, you may use this file as part of a free
// software project without restriction.  Specifically, if other files
// instantiate templates or use macros or inline functions from this
// file, or you compile this file and link it with other files to produce
// an executable, this file does not by itself cause the resulting
// executable to be covered by the GNU General Public License.  This
// exception does not however invalidate any other reasons why the
// executable file might be covered by the GNU General Public License.

#ifndef MLN_CORE_ALL_HH
# define MLN_CORE_ALL_HH

/// \file
///
/// File that includes all the core routines.


// Sub-directories.
# include <mln/core/alias/all.hh>
# include <mln/core/concept/all.hh>
# include <mln/core/def/all.hh>
# include <mln/core/image/all.hh>
# include <mln/core/trait/all.hh>
# include <mln/core/routine/all.hh>
# include <mln/core/site_set/all.hh>

// Local directory.
# include <mln/core/a_point_of.hh>
# include <mln/core/category.hh>
# include <mln/core/dpoints_pixter.hh>
# include <mln/core/contract.hh>
# include <mln/core/dpoint.hh>
# include <mln/core/grids.hh>
# include <mln/core/faces_psite.hh>
# include <mln/core/macros.hh>
# include <mln/core/neighb.hh>
# include <mln/core/pixel.hh>
# include <mln/core/w_window.hh>
# include <mln/core/window.hh>
# include <mln/core/point.hh>
# include <mln/core/pixter1d.hh>
# include <mln/core/pixter2d.hh>
# include <mln/core/pixter3d.hh>
# include <mln/core/box_runstart_piter.hh>
# include <mln/core/dpsites_piter.hh>
# include <mln/core/tags.hh>
# include <mln/core/var.hh>


#endif // ! MLN_CORE_ALL_HH
